#ifndef D4_DEF
#define D4_DEF

// NEW DENISE
#define DENISE_SYS_BUFSIZE 2048

#define MAX_LINE_LENGHT 100

// komendy formatujace wypisywany tekst w konsoli na Amidze
#define RESET_CONSOLE "\033c"
#define CURS_OFF "\033[0 p"
#define CURS_ON "\033[ p"
#define DELETE_CHAR "\033[P"
#define COLOR_01 "\033[31m"
#define COLOR_02 "\033[32m"
#define COLOR_03 "\033[33m"
#define ITALIC "\033[3m"
#define BOLD "\033[1m"
#define UNDERLINE "\033[4m"
#define NORMAL_TEXT "\033[0m"

// file
#if defined(AMIGA)
	#define CONFIG_FILE "config"
	#define LANGUAGES_DIR "languages/"
	#define ACTIVE_LANGUAGE_FILE "active_language"
	#define LOGIC_DIR "logic/"
	#define LOGIC_FACTSCMP_FILE "factscmp.dat"
	#define LOGIC_CONVERSATION_FILE "conversation.dat"
	#define FACTS_DIR "facts/"
	#define FACTS_LIST_FILE "facts-list"
	#define MEANINGS_FILE "meanings.dat"
	#define CONCLUSIONS_FILE "conclusion.dat"
	#define LOGBOOK_DIR "logbook/"
	#define LOGBOOK_WORDS_FILE "words.txt"
	#define LOGBOOK_CLAUSES_FILE "clauses.txt"
	#define LOGBOOK_DIALOG_FILE "dialog.txt"
	#define LOGBOOK_REPORTS_FILE "reports.txt"
	#define TEMP_FILE "temp.tmp"
#elif defined(WIN32)
	#define CONFIG_FILE "config"
	#define LANGUAGES_DIR "languages\\"
	#define ACTIVE_LANGUAGE_FILE "active_language"
	#define LOGIC_DIR "logic\\"
	#define LOGIC_FACTSCMP_FILE "factscmp.dat"
	#define LOGIC_CONVERSATION_FILE "conversation.dat"
	#define FACTS_DIR "facts\\"
	#define FACTS_LIST_FILE "facts-list"
	#define MEANINGS_FILE "meanings.dat"
	#define CONCLUSIONS_FILE "conclusion.dat"
	#define LOGBOOK_DIR "logbook\\"
	#define LOGBOOK_WORDS_FILE "words.txt"
	#define LOGBOOK_CLAUSES_FILE "clauses.txt"
	#define LOGBOOK_DIALOG_FILE "dialog.txt"
	#define LOGBOOK_REPORTS_FILE "reports.txt"
	#define TEMP_FILE "temp.tmp"
#elif defined(UNIX)
	#define CONFIG_FILE "config"
	#define LANGUAGES_DIR "languages/"
	#define ACTIVE_LANGUAGE_FILE "active_language"
	#define LOGIC_DIR "logic/"
	#define LOGIC_FACTSCMP_FILE "factscmp.dat"
	#define LOGIC_CONVERSATION_FILE "conversation.dat"
	#define FACTS_DIR "facts/"
	#define FACTS_LIST_FILE "facts-list"
	#define MEANINGS_FILE "meanings.dat"
	#define CONCLUSIONS_FILE "conclusion.dat"
	#define LOGBOOK_DIR "logbook/"
	#define LOGBOOK_WORDS_FILE "words.txt"
	#define LOGBOOK_CLAUSES_FILE "clauses.txt"
	#define LOGBOOK_DIALOG_FILE "dialog.txt"
	#define LOGBOOK_REPORTS_FILE "reports.txt"
	#define TEMP_FILE "temp.tmp"
#endif

#define OFF 0
#define ON 1

// main commands
#define COMMAND_QUIT "quit"

// typy faktow prostych
#define FSENTENCE 1

// format baz danych
#define DATABASE_START "DATABASE"
#define DATABASE_END "DATABASE_END"
#define DATABASE_COMMENT '#'

// baza faktow
#define THEME_START "THEME"
#define THEME_END "THEME_END"
#define FACT_START "FACT"
#define FACT_END "FACT_END"
#define FACT_SIMPLE_START "FACT_SIMPLE"
#define FACT_SIMPLE_END "FACT_SIMPLE_END"
#define INFORMATION_START "INFORMATION"
#define INFORMATION_END "INFORMATION_END"

// message versions separator - NOT IN THIS VERSION!
//#define MESSAGE_SEPARATOR '|'

// zdanie oznajmujace/pytajace
#define ZDANIE_OZNAJMUJACE 1
#define ZDANIE_PYTAJACE 2

// modul grammar
#define ILE_FUNKCJI 5
// funkcje: 1-podmiot,2-orzeczenie,3-przydawka,4-dopenienie+5-okolicznik
#define WSPOLRZEDNE 0
#define PODRZEDNE 1
#define NADRZEDNE 2

#define SUBJECT_DENISE 1
#define SUBJECT_USER 2
#define SUBJECT_THEME 3
#define SUBJECT_OTHER 4

#define WRITE_WITH_SUBJECT 1
#define WRITE_WITHOUT_SUBJECT 2
#define WRITE_WITH_PRONOUN 3

// conversation - typy i tryby poszukiwanych tematow
#define TYPE_ALIKE 1
#define TYPE_DIFFERENT 2
#define TYPE_KNOWN 3
#define TYPE_UNKNOWN 4
#define TYPE_RANDOM 5

#define MODE_WITHOUT_NEG 1
#define MODE_WITH_NEG 2
#define MODE_FREE 3
#define MODE_NO_MODE 4

// wyrazenie twierdzace, czy zanegowane
#define TWIERDZENIE 1
#define PRZECZENIE 2

// oznaczenie wyrazu negujacego wyrazenie
#define NEG_WORD '!'

// wykorzystywane spojniki logiczne
#define NO_CON 0
#define CON_NOT 1
#define CON_AND 2
#define CON_OR 3
#define CON_XOR 4
#define CON_THEN 5

// wartosci logiczne zdania (musi tak byc! TRUE 1, FALSE 0 <- inaczej beda bledy!!!)
#define LOGIC_TRUE 1
#define LOGIC_FALSE 0

// preferowana odpowiedz (brak preferencji, pelny dowod, tylko wynik)
#define NO_PREFERED 0
#define PREFERED_PROVE 1
#define PREFERED_RESULT 2

// definicje wartosci "parent" w klauzulach (NIE ZMIENIAC!!!)
#define IS_FACT 0
#define IS_HYPOTHESIS -1

// definicje dotyczace konwersacji (plik CONVERSATION.DAT w LOGIC)
#define CONV_IF 	1
#define CONV_THEN 2
#define CONV_AND 	3
#define CONV_OR 	4
#define CONV_NULL 5
// zmienne warunkowe
#define CONV_USER_ANNOUNCE 	10
#define CONV_USER_QUESTION 	11
// akcja: denise answer
#define CONV_DENISE_ANSWER 	20
#define CONV_ANSWER_PREFERED  2001
#define CONV_ANSWER_PROVE     2002
#define CONV_ANSWER_SIMPLE    2003
// akcja: denise question(arg1,arg2,arg3)
#define CONV_DENISE_QUESTION 	21
// arg1
#define CONV_SUBJECT_DENISE 	2111
#define CONV_SUBJECT_USER 		2112
#define CONV_SUBJECT_THEME 	2113
#define CONV_SUBJECT_RANDOM 	2114
#define CONV_SUBJECT_UNKNOWN 	2115
#define CONV_SUBJECT_KNOWN 	2116
// arg2
#define CONV_MOST_ALIKE			2121
#define CONV_MOST_DIFFERENT 	2122
#define CONV_MOST_KNOWN		 	2123
#define CONV_MOST_UNKNOWN		2124
#define CONV_RANDOM				2125
// arg3
#define CONV_WITHOUT_NEG		2131
#define CONV_WITH_NEG			2132
#define CONV_MODE_FREE 			2133
// akcja: denise remember
#define CONV_DENISE_REMEMBER 	22
// zmienne warunkowe wewnetrzne
#define CONV_DENISE_EXIST		30
#define CONV_USER_EXIST			31
#define CONV_THEME_EXIST 		32

// definicje przejsc stanow podczas porownywania faktow
#define FCMP_NULL 1
#define FCMP_A_DIF_B 2
#define FCMP_A_EQU_B 3
#define FCMP_A_IN_B 4
#define FCMP_B_IN_A 5
#define FCMP_A_PR_B 6
#define FCMP_B_PR_A 7
#define FCMP_A_EQU_B_NEG 8
#define FCMP_A_IN_B_NEG 9
#define FCMP_B_IN_A_NEG 10
#define FCMP_A_PR_B_NEG 11
#define FCMP_B_PR_A_NEG 12

// okreslenie zakresu
#define CMP_ALL 1
#define CMP_ONLY_PREDICATE 2
#define CMP_WITHOUT_PREDICATE 3

// w logic - fscmp
#define CMP_ALL_GROUPS 1
#define CMP_WITHOUT_SUBJECT 2

// NULL = 1
#define POSITIV 2
#define NEGATIV 3

#define IDENTIFIED_ONE 1
#define IDENTIFIED_NOTHING 2
#define IDENTIFIED_MORE_SAME 3
#define IDENTIFIED_MORE_ALIKE 4

#define OPERATION_NEXT 1
#define OPERATION_END 2

// tryb identyfikowania: tylko na podstawie grupy podmiotu, innych grup, lub wszystkich
#define ID_FROM_SUBJECT 1
#define ID_FROM_OTHER 2
#define ID_FROM_ALL 3

// declension - wielkosc tablicy wskaznikow odmian (powinna byc duza >100)
#define DECLENSION_MAX_FLEKS 500

// tryby sprawdzania zgodnosci tematow: dokladnie takie same lub zgodne
#define MODE_EXACT 1
#define MODE_COMPATIBLE 2

// prawa uzytkownika
#define MODE_USER 0
#define MODE_SUPERVISOR 1

#endif
