#ifndef DENISE_PROTOS_H
#define DENISE_PROTOS_H

/* Prototypes for functions defined in denise.c
 */

extern ULONG UNN_DosError(FILE* );

extern char * GetLocaleString(ULONG , char * );

extern void SetPrefix(char *);

EXPORT struct DeniseHandle * CALLBACK DeniseOpenTalk(void (* )(char * ),void (* )(char * ));

EXPORT int CALLBACK DeniseTalk(struct DeniseHandle * , char * , char * , int );

EXPORT int CALLBACK DeniseCloseTalk(struct DeniseHandle * );

EXPORT int CALLBACK DeniseSet(struct DeniseHandle * , int , void * );

EXPORT int CALLBACK DeniseGet(struct DeniseHandle * , int , void * );

EXPORT int CALLBACK DeniseLoad(struct DeniseHandle * , int , void * );

EXPORT int CALLBACK DeniseSave(struct DeniseHandle * , int , void * );

extern int DeniseLoadKnowledge(struct DeniseHandle * , int , char * );

EXPORT char * CALLBACK DeniseError(struct DeniseHandle * , int );

EXPORT char * CALLBACK DeniseWarning(struct DeniseHandle * , int );

#ifndef UNIX
EXPORT int STDARGS CALLBACK DeniseMessage(struct DeniseHandle *, const char *, ...);
EXPORT int STDARGS CALLBACK DeniseReport(struct DeniseHandle *, const char *, ...);
#else
extern int DeniseMessage(struct DeniseHandle *, const char *, ...);
extern int DeniseReport(struct DeniseHandle *, const char *, ...);
#endif
#endif
