#ifndef DENISE_ERRORS_H
#define DENISE_ERRORS_H

#include "errno.h"

#define SYS_ERR_BASE				0

#define ERR_NOERR					SYS_ERR_BASE
#define ERR_SYS_UNKNOWN				SYS_ERR_BASE+1		// nieznany blad
#define ERR_SYS_DEADEND				SYS_ERR_BASE+2		// nieznany blad
#define ERR_SYS_NOMEM				SYS_ERR_BASE+3		// brak pamieci
#define ERR_SYS_EMPTYLIST			SYS_ERR_BASE+4		// pusta lista
#define ERR_SYS_INVALIDHANDLE		SYS_ERR_BASE+5
#define ERR_SYS_NULLPOINTER			SYS_ERR_BASE+6
#define ERR_SYS_NOTIMPLEMENTED		SYS_ERR_BASE+7
#define ERR_SYS_INVALIDPARAM		SYS_ERR_BASE+8

#define FILE_ERR_BASE				SYS_ERR_BASE+9

#define ERR_FILE_DEFAULT			FILE_ERR_BASE
#define ERR_FILE_OPENFAILED			FILE_ERR_BASE+1
#define ERR_FILE_NOTFOUND			FILE_ERR_BASE+2
#define ERR_FILE_ACCESSDENIED		FILE_ERR_BASE+3
#define ERR_FILE_IOERROR			FILE_ERR_BASE+4
#define ERR_FILE_DISKFULL			FILE_ERR_BASE+5
#define ERR_FILE_EOF				FILE_ERR_BASE+6
#define ERR_FILE_DELETEFAILED		FILE_ERR_BASE+7
#define ERR_FILE_INVALIDFILENAME	FILE_ERR_BASE+8

#define SYS_WARN_BASE				FILE_ERR_BASE+9

#define WARN_NODENISE				SYS_WARN_BASE

#define DENISE_MAX_ERRORS			SYS_WARN_BASE+1
#endif
