// ***************************************************************************************
//                                  Grammar - Declension
// ***************************************************************************************

#include "denise.h"
#include "denise_protos.h"

// deklaracje prywatne
static BOOL word_exist(struct Declension *decl,int nr,char *data);

// ***************************************************************************************
// EXTERN
// ***************************************************************************************
void test_decl(struct DeniseHandle *handle)
{
	/*
uwzglednianie pol: MUSI BYC W PODRZEDNEJ itp.

	marek,mie,rower

	funkcje: 1-podmiot,2-orzeczenie,3-przydawka,4-dopenienie,5-okolicznik

struct DeclensionWord
{
	char podst[100];
	char wyraz[100];
	char dane[100];
};

struct Declension
{
	int subject;

	int groups_number;
	struct
	{
		int function;
		int parent;

		int words_number;
		struct DeclensionWord word[10];
	} group[20];

	char result[200];
	int person;
};
	*/

	static struct Declension sent;
   int nr1;
/*
#define SUBJECT_DENISE 1
#define SUBJECT_USER 2
#define SUBJECT_THEME 3
#define SUBJECT_OTHER 4*/
//	funkcje: 1-podmiot,2-orzeczenie,3-przydawka,4-dopenienie,5-okolicznik

/*
	sent.subject=SUBJECT_OTHER;
	sent.groups_number=4;

	sent.group[0].function=1;
	sent.group[0].parent=0;
	sent.group[0].words_number=1;
//	sprintf(sent.group[0].word[0].podst,"woda");
	sprintf(sent.group[0].word[0].podst,"marek");
//	sprintf(sent.group[0].word[0].podst,"drzewo");

	sent.group[1].function=2;
	sent.group[1].parent=1;
	sent.group[1].words_number=1;
	sprintf(sent.group[1].word[0].podst,"mie");

	sent.group[2].function=4;
	sent.group[2].parent=2;
	sent.group[2].words_number=1;
	sprintf(sent.group[2].word[0].podst,"samochd");
//	sprintf(sent.group[2].word[0].podst,"rower");

	sent.group[3].function=3;
	sent.group[3].parent=3;
	sent.group[3].words_number=1;
	sprintf(sent.group[3].word[0].podst,"szybki");
*/

// szymon lubi pisa list
// magda byc programista
// dariusz byc programista

	sent.subject=SUBJECT_OTHER;
	sent.write_subject=WRITE_WITH_SUBJECT;
	sent.groups_number=4;

	sent.group[0].function=1;
	sent.group[0].parent=0;
	sent.group[0].words_number=1;
//	sprintf(sent.group[0].word[0].podst,"woda");
	sprintf(sent.group[0].word[0].podst,"szymon");
//	sprintf(sent.group[0].word[0].podst,"drzewo");

	sent.group[1].function=2;
	sent.group[1].parent=1;
	sent.group[1].words_number=1;
	sprintf(sent.group[1].word[0].podst,"lubi");

	sent.group[2].function=4;
	sent.group[2].parent=2;
	sent.group[2].words_number=1;
	sprintf(sent.group[2].word[0].podst,"pisa");
//	sprintf(sent.group[2].word[0].podst,"rower");

	sent.group[3].function=3;
	sent.group[3].parent=3;
	sent.group[3].words_number=1;
	sprintf(sent.group[3].word[0].podst,"list");

	if (gra_declension(handle,&sent)==TRUE)
	{
		DeniseReport(handle,"jest ok");
		for (nr1=0;nr1<sent.results_number;nr1++)
			DeniseReport(handle,"%s (%d/%d)",sent.result[nr1],nr1+1,sent.results_number);
	}
	else
	{
		DeniseReport(handle,"nie udalo sie!");
	}
}

// ***************************************************************************************
// EXTERN
// ***************************************************************************************
void gra_declension_clean(struct Declension *decl)
{
	decl->groups_number=0;
   decl->results_number=0;
}
// ***************************************************************************************
// EXTERN
// ***************************************************************************************
extern BOOL gra_sent_declension(struct DeniseHandle *handle,struct FSentence *fsent,struct Declension *decl,int subject,int write_subject)
{
	/*
   funkcja przygotowuje strukture declension na podstawie zdania (fsent),
   nastepnie funkcja wykorzystuje funkcje gra_declension do odmienienia zdania

	algorytm:
   */

   BOOL result;
   int nr1,nr2,nr3;

	gra_declension_clean(decl); // zabezpieczenie

	decl->subject=subject;
	decl->write_subject=write_subject;
	decl->groups_number=fsent->groups_number;

   for (nr1=0;nr1<decl->groups_number;nr1++)
   {
		decl->group[nr1].function=fsent->function[nr1];
		decl->group[nr1].parent=fsent->parent[nr1];
		decl->group[nr1].words_number=0;

		for (nr2=0;nr2<fsent->ile_fleks;nr2++)
      {
      	for (nr3=0;nr3<fsent->words_number;nr3++)
         {
	      	if (fsent->fleksyjny[nr3]!=nr2+1) continue;
	      	if (fsent->member[nr3]!=nr1+1) continue;

            glo_get_part(fsent->base_words,nr2+1,decl->group[nr1].word[decl->group[nr1].words_number].podst,',');
//DeniseReport(handle,"%s",decl->group[nr1].word[decl->group[nr1].words_number].podst);
				decl->group[nr1].words_number++;
            break;
         }
      }
   }

	result=gra_declension(handle,decl);

//DeniseReport(handle,"%d=%s",decl->results_number,decl->result[0]);

   return result;
}

// ***************************************************************************************
// EXTERN
// ***************************************************************************************
extern BOOL gra_subsent_declension(struct DeniseHandle *handle,struct FSentence *subsent,struct FSentence *fsent,struct Declension *decl,int subject,int write_subject)
{
	/*
   funkcja przygotowuje strukture declension na podstawie podmiotu ze zdania subsent i
   tresci ze zdania fsent,
   nastepnie funkcja wykorzystuje funkcje gra_declension do odmienienia zdania

	algorytm:
   */

   BOOL result;
   int nr1,nr2,nr3,nr4;

	gra_declension_clean(decl); // zabezpieczenie

	decl->subject=subject;
	decl->write_subject=write_subject;
	decl->groups_number=fsent->groups_number;

   for (nr1=0;nr1<decl->groups_number;nr1++)
   {
		// jesli to podmiot, to bierzemy go ze zdania podmiotowego: subsent
   	if (fsent->function[nr1]==1)
      {
      	// szukamy podmiotu w subsent
         for (nr4=0;nr4<subsent->groups_number;nr4++)
         	if (subsent->function[nr4]==1) goto SUBJECT_FOUNDED;
			DeniseReport(handle,"blad w strukturze danych FSencence w bazie faktow!");
         return FALSE;
         SUBJECT_FOUNDED:;

			decl->group[nr1].function=1;
			decl->group[nr1].parent=0;
			decl->group[nr1].words_number=0;

			for (nr2=0;nr2<subsent->ile_fleks;nr2++)
	      {
	      	for (nr3=0;nr3<subsent->words_number;nr3++)
	         {
		      	if (subsent->fleksyjny[nr3]!=nr2+1) continue;
		      	if (subsent->member[nr3]!=nr4+1) continue;

	            glo_get_part(subsent->base_words,nr2+1,decl->group[nr1].word[decl->group[nr1].words_number].podst,',');
//DeniseReport(handle,"%s",decl->group[nr1].word[decl->group[nr1].words_number].podst);
					decl->group[nr1].words_number++;
	            break;
	         }
	      }
      }
      else
		{
			decl->group[nr1].function=fsent->function[nr1];
			decl->group[nr1].parent=fsent->parent[nr1];
			decl->group[nr1].words_number=0;

			for (nr2=0;nr2<fsent->ile_fleks;nr2++)
	      {
	      	for (nr3=0;nr3<fsent->words_number;nr3++)
	         {
		      	if (fsent->fleksyjny[nr3]!=nr2+1) continue;
		      	if (fsent->member[nr3]!=nr1+1) continue;

	            glo_get_part(fsent->base_words,nr2+1,decl->group[nr1].word[decl->group[nr1].words_number].podst,',');
//DeniseReport(handle,"%s",decl->group[nr1].word[decl->group[nr1].words_number].podst);
					decl->group[nr1].words_number++;
	            break;
	         }
	      }
	   }
		if (decl->group[nr1].words_number==0)
      {
      	DeniseReport(handle,"blad!!!! grammar2.c totalnie fatalnie");
         return FALSE;
      }
   }

	result=gra_declension(handle,decl);

//DeniseReport(handle,"%d=%s",decl->results_number,decl->result[0]);

   return result;
}

extern BOOL gra_declension(struct DeniseHandle *handle,struct Declension *decl)
{
	/*
	odmiana zdania:
	1. okreslenie osoby czasownika
	- sprawdzamy jaki jest temat:
		- SUBJECT_DENISE	-> osoba 1
		- SUBJECT_USER 	-> osoba 2
		- SUBJECT_THEME 	-> osoba 3
		- SUBJECT_OTHER 	-> osoba 3
	2. odmieniamy wyrazy w kazdej grupie
	- ustalamy kolejne poziomy w strukturze zdania
	- pobieramy kolejne grupy, ktore sa na tym poziomie
		- odmieniamy grupe zgodnie z zasadami gramatycznymi:
		- ustalamy schemat odmiany
		- pobieramy kolejne wyrazy z grupy
			- odmieniamy kazdy zgodnie ze schematem
   */

   struct GrammarLo6Data *lo6;
	struct GrammarLo8Data *lo8;
	struct GrammarFuncData *gra; //,*type[500];
	struct DeclensionWord *word;
	struct Fleksja *fleks,**allfleks;
	struct Odmiany *odm;
   char posneg=TWIERDZENIE;
	int poz,poziom,nr1,nr2,nr3,nr4,nr5,nr6,nr7,nr8,nr9,nr10,mode,gra_poz,parent; //,types_number;
	char temp[1000],temp1[1000],temp2[100],temp3[100],temp4[100],temp5[100],temp6[100],temp7[100],table[20][100];
	int k1;

	// kasujemy pozycje, ktore mamy wypelnic
	decl->results_number=0;
	decl->person=0;

	for (nr1=0;nr1<decl->groups_number;nr1++)
	{
		decl->group[nr1].types_number=0;
		for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
		{
			word=&(decl->group[nr1].word[nr2]);
			word->fleks_number=0;
//         DeniseReport(handle,"GROUP %d - WORD %d = %s",nr1+1,nr2+1,word->podst);
		}
	}
//DeniseReport(handle,"groupY: %d",decl->groups_number);

	// okreslenie osoby czasownika
	// sprawdzamy jaki jest temat:
	switch (decl->subject)
	{
		case SUBJECT_DENISE: decl->person=1; break;
		case SUBJECT_USER: decl->person=2; break;
		case SUBJECT_THEME:
		case SUBJECT_OTHER: decl->person=3; break;
		default:
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_WRONG_DECLENSION_STRUCTURE,"modul odmiany - blednie wypelniona struktura declension"));
			return FALSE;
	}

	// odmieniamy wyrazy w kazdej grupie
	// ustalamy kolejne poziomy w strukturze zdania (podmiot jest na poziomie 1)
	// zaczynamy od poziomu drugiego (gdyz musi byc grupa nadrzedna)
	for (poziom=2;poziom<decl->groups_number+1;poziom++)
	{
		// pobieramy kolejne grupy, ktore sa na tym poziomie
		for (nr1=0;nr1<decl->groups_number;nr1++)
		{
			// okreslamy poziom grupy
			for (nr2=1,nr3=nr1;;nr2++)
			{
				if (decl->group[nr3].parent==0) break;
				nr3=decl->group[nr3].parent-1;
			}

			if (nr2!=poziom) continue;
			parent=decl->group[nr1].parent-1;
//DeniseReport(handle,"poziom: %d, grupa: %s",poziom,decl->group[nr1].word[0].podst);

			// szukamy w gr7 pozycji, ktore pasuja do grupy aktualnej i nadrzednej do niej
			// i dopisujemy pozycje do tablicy w grupie

			// zapisujemy funkcje w formacie prostym
			sprintf(temp,"%d%d",decl->group[parent].function,decl->group[nr1].function);
		   for (gra_poz=0;gra_poz<100;gra_poz++)
		   {
		      for (gra=handle->language.gr7[gra_poz];gra!=NULL;gra=gra->next)
				{
					// sprawdzamy, czy pozycja jest zgodna z opisem grupy podrzednej i nadrzednej

					// czy pozycja dotyczy badanych grup pod wzgledem funkcji w zdaniu
	            // jest format prosty: 12;..;34;56
//DeniseMessahe(handle,"!%s!=!%s!",gra->func,temp);
					if (strstr(gra->func,temp)==NULL) continue;
//DeniseReport(handle,"founded: %s (gr %d - types nr: %d)",gra->data,nr1+1,decl->group[nr1].types_number+1);

					// dopisanie na liste tymczasowa
					decl->group[nr1].type[decl->group[nr1].types_number]=gra;
					decl->group[nr1].types_number++;
				}
			}

			if (decl->group[nr1].types_number==0) DeniseReport(handle,"grammar2.c thing about this... ERROR");
		}
	}

	/*
   pobranie fleksji

	pobieramy kolejne grupy
	pobieramy kolejne mozliwe opisy zwiazkow dla tego wyrazu (grupy):
	- z grupy aktualnej, (mode=1) (opis jako grupa podrzedna do jakiejs nadrzednej)
	- z grup podrzednych (jesli sa), (mode=2);
	pobieramy kolejne wyrazy z grupy
	szukamy odpowiedniej fleksji w bazie fleksji:
	- jesli jest, to zapamietujemy wspolrzedne w tablicy podrecznej
	- jesli nie ma, to kasujemy odpowiedni opis,
	*/
/*
	for (nr1=0;nr1<decl->groups_number;nr1++)
		for (nr2=0;nr2<decl->group[nr1].types_number;nr2++)
			DeniseReport(handle,"grupa: %s, opis (N+grupa)=%s (function: %s)",decl->group[nr1].word[0].podst,decl->group[nr1].type[nr2]->data,decl->group[nr1].type[nr2]->func);
*/

	// pobieramy kolejne grupy
	for (nr1=0;nr1<decl->groups_number;nr1++)
	{
		// pobieramy kolejne mozliwe opisy zwiazkow dla tego wyrazu (grupy):
		mode=1; // z grupy aktualenj
		START3:;
		for (nr2=0;nr2<decl->groups_number;nr2++)
		{
			// z grupy aktualnej, (mode=1);
			if (mode==1)
			{
				if (nr2!=nr1) continue;

				// jesli grupa aktualna nie ma grup nadrzednych, to pomijamy ten tyb
				if (decl->group[nr1].parent==0)
				{
					mode=2;
					goto START3;
				}

				// liczba opisow
				nr3=decl->group[nr1].types_number;
			}
			// z grup podrzednych (jesli sa),
			else
			{
				// nie moze dotyczyc tej samej grupy
				if (nr2==nr1) continue;

				// jesli to nie jest grupa podrzedna do grupy nr1, to nastepna
				if (decl->group[nr2].parent!=nr1+1) continue;

				// liczba opisow
				nr3=decl->group[nr2].types_number;
			}

//DeniseReport(handle,"GRUPA NR1: !%d! (nr2: %d) (%s)",nr1,nr2,decl->group[nr1].word[0].podst);

			// pobieramy kolejne opisy
			nr4=0;
			START4:;
			if (nr3==0)
			{
				DeniseReport(handle,UNN_GetLocaleString(handle,MSG_MISSING_DECLENSION_DATA,"brak danych odmiany dla grupy: %s"),mode==1 ? decl->group[nr1].word[0].podst : decl->group[nr2].word[0].podst);
				return FALSE;
			}

			for (;nr4<nr3;nr4++)
			{
				// pobieramy wymagany opis dla grupy nr1
				// z grupy aktualnej (opis grupy podrzednej dotyczy tej grupy)
				if (mode==1) glo_get_part(decl->group[nr1].type[nr4]->data,2,temp,'+');
				// z grupy podrzednej (opis grupy nadrzednej dotyczy aktualnej grupy)
				else glo_get_part(decl->group[nr2].type[nr4]->data,1,temp,'+');

//DeniseReport(handle,"SEARCHING FOR: %s",temp);

				// pobieramy kolejne wyrazy z grupy
				nr6=0; // oznacza, ze nie znaleziono fleksji odpowiadajacej opisowi
				for (nr5=0;nr5<decl->group[nr1].words_number;nr5++)
				{
					word=&(decl->group[nr1].word[nr5]);
//DeniseReport(handle,"(group: %d): slowo: !%s!",nr1,word->podst);

					// szukamy odpowiedniej fleksji w bazie fleksji:
						 allfleks=dat_find_word(handle,handle->language.vocabulary,word->podst,"","",0);
		         for (fleks=*allfleks,k1=0;fleks!=NULL;k1++,fleks=allfleks[k1])
		         for (odm=fleks->odm_head;odm!=NULL;odm=odm->next)
					{
						nr7=glo_count_parts(handle,odm->odmiany,',');
						for (poz=0;poz<nr7;poz++)
						{
                  	// warunek: jakas odmiana musi istniec (tzn. musi byc podana)
                     glo_get_part(odm->odmiany,poz+1,temp1,',');
                     if (strlen(temp1)==0) continue;

							// tworzymy opis zakodowany
         				if (nr7>1) sprintf(temp1,"%s%c",odm->opis,poz+'A');
         				else sprintf(temp1,"%s",odm->opis);

							// jesli opisy sa zgodne, to zapamietujemy wspolrzedne w tablicy podrecznej
							// i zapamietujemy, ze znaleziono opis
//DeniseReport(handle,"(%s) %s=%s...",word->podst,temp,temp1);
							if (gra_wyrazenie_check(handle,&posneg,temp,temp1)==1)
							{
								nr6=1;
								word->fleks[word->fleks_number]=fleks;
								word->odm[word->fleks_number]=odm;
								word->poz[word->fleks_number]=poz+1;
                        if (word->fleks_number<DECLENSION_MAX_FLEKS-1) word->fleks_number++;
                        else DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DECLENSION_TABLE_TOO_SMALL,"uwaga! zbyt mala tablica fleksji w strukturze odmiany!"));
//DeniseReport(handle,"FOUNDED slowo: !%s! (%s=%s) (fleks_number=%d)",word->podst,temp1,temp,word->fleks_number);
//DeniseReport(handle,"OK");
							}
							else
							{
//DeniseReport(handle,"FALSE");
							}
//DeniseReport(handle,"1 FOUNDED slowo: !%s! (%s=%s)",word->podst,temp1,temp);
						}
					}
				  free(allfleks); 
				}

				if (nr6==0)
				{
					// jesli nie znaleziono fleksji pasujacej do opisu, to kasujemy opis
					// z grupy aktualnej, (mode=1);
					if (mode==1)
					{
						decl->group[nr1].type[nr4]=decl->group[nr1].type[decl->group[nr1].types_number-1];
						decl->group[nr1].types_number--;
					}
					// z grup podrzednych (jesli sa),
					else
					{
						decl->group[nr2].type[nr4]=decl->group[nr2].type[decl->group[nr2].types_number-1];
						decl->group[nr2].types_number--;
					}
					nr3--;
					goto START4;
				}
//				OPIS_FOUNDED:; // jesli znaleziono fleksje wyrazu pasujacego do opisu to ok
			}
		}
		mode++;
		if (mode==2) goto START3; // tryb z grup podrzednych
	}

	// eliminujemy te same (powtorzone) opisy
   for (nr1=0;nr1<decl->groups_number;nr1++)
   {
   	for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
      {
      	for (nr3=0;nr3<decl->group[nr1].word[nr2].fleks_number-1;nr3++)
         {
            for (nr4=nr3+1;nr4<decl->group[nr1].word[nr2].fleks_number;nr4++)
            {
            	if (decl->group[nr1].word[nr2].fleks[nr3]!=decl->group[nr1].word[nr2].fleks[nr4]) continue;
            	if (decl->group[nr1].word[nr2].odm[nr3]!=decl->group[nr1].word[nr2].odm[nr4]) continue;
            	if (decl->group[nr1].word[nr2].poz[nr3]!=decl->group[nr1].word[nr2].poz[nr4]) continue;

					// kasujemy odmiane
               decl->group[nr1].word[nr2].fleks[nr4]=decl->group[nr1].word[nr2].fleks[decl->group[nr1].word[nr2].fleks_number-1];
               decl->group[nr1].word[nr2].odm[nr4]=decl->group[nr1].word[nr2].odm[decl->group[nr1].word[nr2].fleks_number-1];
               decl->group[nr1].word[nr2].poz[nr4]=decl->group[nr1].word[nr2].poz[decl->group[nr1].word[nr2].fleks_number-1];
               decl->group[nr1].word[nr2].fleks_number--;
               nr4--;
            }
         }
      }
   }

	/*
   uwzglednienie kryteriow zewnetrznych:
   - osoba (na bazie danych z pliku *.lo6),
   <- czas,>

	eliminujemy te odmiany, ktore nie spelniaja tych warunkow

	algorytm:
   - pobieramy kolejne odmiany,
   - pobieramy kolejne pozycje z lo6,
   - jesli odmiana tego wyrazu ma wplyw na osobe, to sprawdzamy, czy
     jest zgodna z przyjeta osoba; jesli nie, to kasujemy odmiane,
   */

   // pobieramy kolejne odmiany,
   for (nr1=0;nr1<decl->groups_number;nr1++)
   for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
   {
		nr3=0;
      EXT1:;
   	if (decl->group[nr1].word[nr2].fleks_number==0)
      {
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DECLENSION_OUT_OF_DATA,"brak danych fleksyjnych lub gramatycznych przy odmianie zdania"));
         return FALSE;
      }

   	for (;nr3<decl->group[nr1].word[nr2].fleks_number;nr3++)
      {
			nr4=glo_count_parts(handle,decl->group[nr1].word[nr2].odm[nr3]->odmiany,',');

			if (nr4>1) sprintf(temp,"%s%c",decl->group[nr1].word[nr2].odm[nr3]->opis,decl->group[nr1].word[nr2].poz[nr3]+'A'-1);
			else sprintf(temp,"%s",decl->group[nr1].word[nr2].odm[nr3]->opis);

			// pobieramy kolejne pozycje z lo6,
		   for (lo6=handle->language.lo6;lo6!=NULL;lo6=lo6->next)
		   {
		      // sprawdzamy czy wyraz fleksyjny jest zgodny z pozycja,
		      if (lo6->func!=decl->group[nr1].function) continue;
		      if (gra_wyrazenie_check(handle,&posneg,lo6->czesc_mowy,temp)==0) continue;
		      // jesli TAK, to sprawdzamy, czy jest zgodna z przyjeta osoba;
            // jesli nie, to kasujemy odmiane,
				if (lo6->person!=decl->person)
            {
					decl->group[nr1].word[nr2].fleks[nr3]=decl->group[nr1].word[nr2].fleks[decl->group[nr1].word[nr2].fleks_number-1];
					decl->group[nr1].word[nr2].odm[nr3]=decl->group[nr1].word[nr2].odm[decl->group[nr1].word[nr2].fleks_number-1];
					decl->group[nr1].word[nr2].poz[nr3]=decl->group[nr1].word[nr2].poz[decl->group[nr1].word[nr2].fleks_number-1];
					decl->group[nr1].word[nr2].fleks_number--;
	         	goto EXT1;
            }
		   }
		}
	}

	/*
	kontrola poprawnosci polaczen miedzy grupami dla znalezionych danych fleksyjnych
	kazda odmiana fleksyjna wyrazu musi byc zgodna w sensie chociaz jednego znalezionego
   zwiazku, z odmianami wyrazow wszystkich grup polaczonych podrzednie lub nadrzednie.

   kasujemy odmiany, ktore na pewno nie sa dobre - nie pasuja do zadnego zwiazku

   algorytm:
	- zerujemy wskazniki uzytecznosci opisow i odmian,
	- pobieramy kolejne grupy (A),
	   - pobieramy kolejne wyrazy (1) z grupy A,
		   - pobieramy kolejne odmiany wyrazu 1 (O1),
				- pobieramy kolejne grupy (B) nadrzedne lub podrzedne do grupy A,
					- pobieramy kolejne wyrazy (2) z grupy B,
						- pobieramy kolejne odmiany wyrazu 2 (O2),
							- sprawdzamy wszystkie zwiazki gramatyczne wiazace grupe A z B,
							   - jesli wyrazy o odmianach O1 i O2 moga byc poprawnie polaczone,
                          to zwiekszamy indeksy wykorzystania tych odmian i zwiazku,
	*/

	// zerujemy wskazniki uzytecznosci opisow i odmian,
   for (nr1=0;nr1<decl->groups_number;nr1++)
   {
		for (nr2=0;nr2<decl->group[nr1].types_number;nr2++)
		{
			decl->group[nr1].utility[nr2]=0;
      }
		for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
		{
      	for (nr3=0;nr3<decl->group[nr1].word[nr2].fleks_number;nr3++)
         {
				decl->group[nr1].word[nr2].utility[nr3]=0;
         }
      }
   }

//DeniseReport(handle,"PART II");

	// pobieramy kolejne grupy (A),
	for (nr1=0;nr1<decl->groups_number;nr1++)
   {
	   // pobieramy kolejne wyrazy (1) z grupy A,
		for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
      {
		   // pobieramy kolejne odmiany wyrazu 1 (O1),
			for (nr3=0;nr3<decl->group[nr1].word[nr2].fleks_number;nr3++)
         {
         	// w temp1 dane 01, w temp2 dane 02,
				nr4=glo_count_parts(handle,decl->group[nr1].word[nr2].odm[nr3]->odmiany,',');
  				if (nr4>1) sprintf(temp1,"%s%c",decl->group[nr1].word[nr2].odm[nr3]->opis,decl->group[nr1].word[nr2].poz[nr3]+'A'-1);
  				else sprintf(temp1,"%s",decl->group[nr1].word[nr2].odm[nr3]->opis);

           	// pobieramy kolejne grupy (B) nadrzedne lub podrzedne do grupy A,
				for (nr4=0;nr4<decl->groups_number;nr4++)
			   {
            	// jaka to grupa (mode=0: A<-B, mode=1: B<-A)
            	if (decl->group[nr1].parent==nr4+1)
               {
               	mode=1;
                  nr8=decl->group[nr1].types_number;
               }
					else if (decl->group[nr4].parent==nr1+1)
               {
               	mode=0;
                  nr8=decl->group[nr4].types_number;
               }
               else continue;

               // pobieramy kolejne wyrazy (2) z grupy B,
					for (nr5=0;nr5<decl->group[nr4].words_number;nr5++)
			      {
						// pobieramy kolejne odmiany wyrazu 2 (O2),
                  for (nr6=0;nr6<decl->group[nr4].word[nr5].fleks_number;nr6++)
                  {
			         	// w temp1 dane 01, w temp2 dane 02,
							nr7=glo_count_parts(handle,decl->group[nr4].word[nr5].odm[nr6]->odmiany,',');
			  				if (nr7>1) sprintf(temp2,"%s%c",decl->group[nr4].word[nr5].odm[nr6]->opis,decl->group[nr4].word[nr5].poz[nr6]+'A'-1);
			  				else sprintf(temp2,"%s",decl->group[nr4].word[nr5].odm[nr6]->opis);

							// sprawdzamy wszystkie zwiazki gramatyczne wiazace grupe A z B,
                     for (nr7=0;nr7<nr8;nr7++)
                     {
                     	// pobieramy odpowiedni opis zwiazku
								// A<-B
                        if (mode==0) sprintf(temp,"%s",decl->group[nr4].type[nr7]->data);
								// B<-A
                        else if (mode==1) sprintf(temp,"%s",decl->group[nr1].type[nr7]->data);

								// sprawdzenie zwiazku
								if (mode==0) nr9=gra_wyrazenie_check(handle,&posneg,temp,temp1,temp2);
								else if (mode==1) nr9=gra_wyrazenie_check(handle,&posneg,temp,temp2,temp1);

//DeniseReport(handle,"%d=%s=%s+%s",nr9,temp,mode==0 ? temp1 : temp2,mode==0 ? temp2 : temp1);

							   // jesli wyrazy o odmianach O1 i O2 moga byc poprawnie polaczone,
                        // to zwiekszamy indeksy wykorzystania tych odmian i zwiazku,
                        if (nr9==1)
                        {
//DeniseReport(handle,"YES! %s=%s+%s",temp,mode==0 ? temp1 : temp2,mode==0 ? temp2 : temp1);
									// uzytecznosc zwiazku
                           if (mode==0) decl->group[nr4].utility[nr7]++;
                           else if (mode==1) decl->group[nr1].utility[nr7]++;

                           // uzytecznosc odmiany O1
                           decl->group[nr1].word[nr2].utility[nr3]++;
                           // uzytecznosc odmiany O2
                           decl->group[nr4].word[nr5].utility[nr6]++;
                        }
                  	}
                  }
               }
            }
         }
      }
   }

   // kasujemy opisy i odmiany, ktore nie uzyskaly zadnych punktow uzytecznosci
   for (nr1=0;nr1<decl->groups_number;nr1++)
   {
		nr2=0;
      UTIL1:;
      if (decl->group[nr1].types_number==0 && decl->group[nr1].parent!=0)
      {
			DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DECLENSION_OUT_OF_DATA,"brak danych fleksyjnych lub gramatycznych przy odmianie zdania"));
         return FALSE;
      }
	  	for (;nr2<decl->group[nr1].types_number;nr2++)
      {
         if (decl->group[nr1].utility[nr2]==0)
         {
				decl->group[nr1].type[nr2]=decl->group[nr1].type[decl->group[nr1].types_number-1];
				decl->group[nr1].utility[nr2]=decl->group[nr1].utility[decl->group[nr1].types_number-1];
				decl->group[nr1].types_number--;
         	goto UTIL1;

//DeniseReport(handle,"fe grupa: %s",decl->group[nr1].word[0].podst);
         }
      }

      for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
      {
			nr3=0;
	      UTIL2:;
	      if (decl->group[nr1].word[nr2].fleks_number==0)
	      {
				DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DECLENSION_OUT_OF_DATA,"brak danych fleksyjnych lub gramatycznych przy odmianie zdania"));
	         return FALSE;
	      }

		  	for (;nr3<decl->group[nr1].word[nr2].fleks_number;nr3++)
  			{
         	if (decl->group[nr1].word[nr2].utility[nr3]==0)
	         {
//DeniseReport(handle,"fe odmiana: %s",decl->group[nr1].word[0].podst);

					decl->group[nr1].word[nr2].fleks[nr3]=decl->group[nr1].word[nr2].fleks[decl->group[nr1].word[nr2].fleks_number-1];
					decl->group[nr1].word[nr2].odm[nr3]=decl->group[nr1].word[nr2].odm[decl->group[nr1].word[nr2].fleks_number-1];
					decl->group[nr1].word[nr2].poz[nr3]=decl->group[nr1].word[nr2].poz[decl->group[nr1].word[nr2].fleks_number-1];
					decl->group[nr1].word[nr2].utility[nr3]=decl->group[nr1].word[nr2].utility[decl->group[nr1].word[nr2].fleks_number-1];
					decl->group[nr1].word[nr2].fleks_number--;
	         	goto UTIL2;
				}
         }
      }
   }

	/*
   wybor ostatecznej struktury

   algorytm:
   - ustawiamy parametry na mozliwosc pierwsza,
   - sprawdzamy wszystkie mozliwosci doboru opisow i odmian,
   - jesli ustawienie jest mozliwe, to zapamietujemy je jako opcja,
   */

   // ustawiamy parametry na mozliwosc pierwsza,
   for (nr1=0;nr1<decl->groups_number;nr1++)
   {
		// opis pierwszy
      if (decl->group[nr1].parent!=0) decl->group[nr1].selected=1;

      // pierwsze odmiany
      for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
			decl->group[nr1].word[nr2].selected=1;
   }

   // sprawdzamy wszystkie mozliwosci doboru opisow i odmian,
//	nr10=0;
	goto OCENKA;
   for (;;)
   {
		// szukamy pierwszej mozliwej do zmiany odmiany
		for (nr1=0;nr1<decl->groups_number;nr1++)
      {
      	for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
         {
         	// jesli mozna zmienic odmiane na nastepna...
            if (decl->group[nr1].word[nr2].selected<decl->group[nr1].word[nr2].fleks_number)
            {
					// to zmieniamy
					decl->group[nr1].word[nr2].selected++;
               // i ocena
               goto OCENKA;
            }
            // jesli nie mozna, to musimy wyzerowac numer odmiany dla tego slowa
				decl->group[nr1].word[nr2].selected=1;
         }
      }
      // jesli nie mozna zmienic odmiany, to
      // zerujemy wszystkie odmiany
	   for (nr1=0;nr1<decl->groups_number;nr1++)
	   {
	      // pierwsze odmiany
	      for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
				decl->group[nr1].word[nr2].selected=1;
	   }

		// zmieniamy opisy na kolejne (w ten sam sposob jak odmiany)
		// szukamy pierwszego mozliwego do zmiany opisu
		for (nr1=0;nr1<decl->groups_number;nr1++)
      {
      	if (decl->group[nr1].parent==0) continue;

        	// jesli mozna zmienic opis na nastepny...
         if (decl->group[nr1].selected<decl->group[nr1].types_number)
         {
				// to zmieniamy
				decl->group[nr1].selected++;
            // i ocena
            goto OCENKA;
         }
         // jesli nie mozna, to musimy wyzerowac numer odmiany dla tego slowa
			decl->group[nr1].selected=1;
      }
      // jesli nie mozna zmienic opisu, to koniec mozliwosci
		break;

      OCENKA:;
//nr10++;
//DeniseReport(handle,"number: %d",nr10);
      // oceniamy tak ustalony rozbior zdania
      // pobieramy kolejne grupy i sprawdzamy zwiazek z grupa nadrzedna
      for (nr1=0;nr1<decl->groups_number;nr1++)
      {
      	if (decl->group[nr1].parent==0) continue;

         nr2=decl->group[nr1].parent-1;

         // pobieramy odpowiednie fleksje
			nr3=glo_count_parts(handle,decl->group[nr1].word[0].odm[decl->group[nr1].word[0].selected-1]->odmiany,',');
			if (nr3>1) sprintf(temp1,"%s%c",decl->group[nr1].word[0].odm[decl->group[nr1].word[0].selected-1]->opis,decl->group[nr1].word[0].poz[decl->group[nr1].word[0].selected-1]+'A'-1);
			else sprintf(temp1,"%s",decl->group[nr1].word[0].odm[decl->group[nr1].word[0].selected-1]->opis);

			nr3=glo_count_parts(handle,decl->group[nr2].word[0].odm[decl->group[nr2].word[0].selected-1]->odmiany,',');
			if (nr3>1) sprintf(temp2,"%s%c",decl->group[nr2].word[0].odm[decl->group[nr2].word[0].selected-1]->opis,decl->group[nr2].word[0].poz[decl->group[nr2].word[0].selected-1]+'A'-1);
			else sprintf(temp2,"%s",decl->group[nr2].word[0].odm[decl->group[nr2].word[0].selected-1]->opis);

			if (gra_wyrazenie_check(handle,&posneg,decl->group[nr1].type[decl->group[nr1].selected-1]->data,temp2,temp1)==0) goto NOT_GOOD;

			// nr2 - nadrzedna, nr1 - podrzedna,

			// warunek: musi byc w nadrzednej (czesc mowy)
			if (decl->group[nr1].type[decl->group[nr1].selected-1]->memb_nadrz!=NULL)
         	if (word_exist(decl,nr2,decl->group[nr1].type[decl->group[nr1].selected-1]->memb_nadrz)==FALSE) goto NOT_GOOD;

         // warunek: musi byc w podrzednej (czesc mowy)
			if (decl->group[nr1].type[decl->group[nr1].selected-1]->memb_podrz!=NULL)
         	if (word_exist(decl,nr1,decl->group[nr1].type[decl->group[nr1].selected-1]->memb_podrz)==FALSE) goto NOT_GOOD;

         // warunek: nie moze byc w nadrzednej (czesc mowy)
			if (decl->group[nr1].type[decl->group[nr1].selected-1]->zakaz_nadrz!=NULL)
         	if (word_exist(decl,nr2,decl->group[nr1].type[decl->group[nr1].selected-1]->zakaz_nadrz)==TRUE) goto NOT_GOOD;

			// warunek: nie moze byc w podrzednej (czesc mowy)
			if (decl->group[nr1].type[decl->group[nr1].selected-1]->zakaz_podrz!=NULL)
         	if (word_exist(decl,nr1,decl->group[nr1].type[decl->group[nr1].selected-1]->zakaz_podrz)==TRUE) goto NOT_GOOD;
      }

      // znaleziono akceptowalny uklad zdania
//DeniseReport(handle,"yes!");

      /*
      przepisujemy wyrazy do zdania

      wyraz z funkcja 1 (podmiot) - POCZATEK
      wyraz z funkcja 2 (orzeczenie) na prawo od nadrzednego
      wyraz z funkcja 3 (przydawka) na lewo od nadrzednego
      wyraz z funkcja 4 (dopelnienie) na prawo od nadrzednego
      wyraz z funkcja 5 (okolicznik) na lewo od nadrzednego

      wyraz z funkcja 3 (przydawka) nie moze byc miedzy podmiotem a orzeczeniem


wode pije komputer dobra
pije wode komputer dobra
wode komputer pije dobra
dobra komputer pije wode
pije komputer dobra wode
komputer pije dobra wode

???

      */

      // ustalamy kolejnosc zapisu grup w zdaniu
		for (nr1=0;nr1<decl->groups_number;nr1++)
      	temp3[nr1]=nr1+1; // pozycja[nr1]=grupa nr1+1

		// ustalamy pozycje
      GOGO:;
      for (nr1=0;nr1<decl->groups_number;nr1++)
		{
      	if (decl->group[temp3[nr1]-1].parent==0) continue;

         // szukamy nadrzednej
         for (nr2=0;nr2<decl->groups_number;nr2++)
         {
         	if (nr1==nr2) continue;

            if (decl->group[temp3[nr1]-1].parent==temp3[nr2])
            {
            	switch (decl->group[temp3[nr1]-1].function)
               {
						// wyraz z funkcja 2 (orzeczenie) na prawo od nadrzednego
               	case 2:
      				// wyraz z funkcja 4 (dopelnienie) na prawo od nadrzednego
                  case 4:
							if (nr1<nr2)
                     {
								if (nr2<decl->groups_number-1)
                        {
	                        nr3=temp3[nr1];
									temp3[nr1]=temp3[nr2+1];
	                        temp3[nr2+1]=nr3;
                        }
								else
                        {
	                        nr3=temp3[nr1];
									temp3[nr1]=temp3[nr2];
	                        temp3[nr2]=nr3;
                        }
								goto GOGO;
                     }
                    	break;

				      // wyraz z funkcja 3 (przydawka) na lewo od nadrzednego
                  case 3:
							if (nr1>nr2)
                     {
                        nr3=temp3[nr1];
								if (nr2>0)
                        {
									temp3[nr1]=temp3[nr2-1];
	                        temp3[nr2-1]=nr3;
                        }
                        else
                        {
									temp3[nr1]=temp3[nr2];
	                        temp3[nr2]=nr3;
                        }
  								goto GOGO;
                     }

							// wyraz z funkcja 3 (przydawka) nie moze byc miedzy podmiotem a orzeczeniem
                     for (nr3=nr1+1;nr3<nr2;nr3++)
                     {
								// jesli to podmiot, to OK, break
                     	if (decl->group[temp3[nr3]-1].function==1) break;

								// jesli to orzeczenie, to musimy wyraz przesunac w prawo
                     	if (decl->group[temp3[nr3]-1].function==2)
                        {
	                        nr3=temp3[nr1];
									temp3[nr1]=temp3[nr1+1];
                           temp3[nr1+1]=nr3;
                        	goto GOGO;
                        }
                     }
                    	break;
      				// wyraz z funkcja 5 (okolicznik) na lewo od nadrzednego
                  case 5:
							if (nr1>nr2)
                     {
                        nr3=temp3[nr1];
								if (nr2>0)
                        {
									temp3[nr1]=temp3[nr2-1];
	                        temp3[nr2-1]=nr3;
                        }
                        else
                        {
									temp3[nr1]=temp3[nr2];
	                        temp3[nr2]=nr3;
                        }
  								goto GOGO;
                     }
                    	break;
               }
               goto OKIDOKI;
            }
         }
         OKIDOKI:;
      }

		// zapis
      for (nr1=0;nr1<decl->groups_number;nr1++)
      {
      	// zapisujemy wszystkie wyrazy
			temp[0]='\0';
         sprintf(temp1," ");
         for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
         {
         	// bierzemy slowo
				glo_get_part(decl->group[nr1].word[nr2].odm[decl->group[nr1].word[nr2].selected-1]->odmiany,decl->group[nr1].word[nr2].poz[decl->group[nr1].word[nr2].selected-1],temp2,',');

            // zapamietujemy
				if (temp[0]=='\0') sprintf(temp,"%s",temp2);
            else
            {
               strcat(temp,temp1);
               strcat(temp,temp2);
            }
         }

			// zapamietujemy w tablicy
         strcpy(table[nr1],temp);
      }

      // zapisujemy zdanie
		temp[0]='\0';
      for (nr1=0;nr1<decl->groups_number;nr1++)
      {
      	// jesli to grupa podmiotu
         if (decl->group[nr1].function==1)
         {
 				// i jest tryb, ze podmiot jest domyslny, to pomijamy
          	if (decl->write_subject==WRITE_WITHOUT_SUBJECT) continue;
				// jesli mamy zastapic zaimkiem, to zastepujemy
            else if (decl->write_subject==WRITE_WITH_PRONOUN)
            {
					// do temp4 dane podmiotu
			 		nr2=glo_count_parts(handle,decl->group[nr1].word[0].odm[decl->group[nr1].word[0].selected-1]->odmiany,',');
			 		if (nr2>1) sprintf(temp4,"%s%c",decl->group[nr1].word[0].odm[decl->group[nr1].word[0].selected-1]->opis,decl->group[nr1].word[0].poz[decl->group[nr1].word[0].selected-1]+'A'-1);
					else sprintf(temp4,"%s",decl->group[nr1].word[0].odm[decl->group[nr1].word[0].selected-1]->opis);

            	// szukamy zaimka, z lo8, ktory jest odpowiedni dla osoby w zdaniu
				   for (lo8=handle->language.lo8;lo8!=NULL;lo8=lo8->next)
               {
               	// jesli to zaimek zgodny z osoba i moze byc w podmiocie...
               	if (lo8->type==1 && lo8->person==decl->person)
                  {
                  	// w temp5 parametry fleksji zaimka szukanego
							glo_get_part(lo8->cmp_data,1,temp5,'+');

							// pobieramy kolejne wyrazy, ktore spelniaja warunki bycia tym zaimkiem
							// szukamy odpowiedniej fleksji w bazie fleksji:
							nr3=glo_count_parts(handle,temp5,',');
							temp6[0]='\0';
                     for (nr2=0;nr2<nr3;nr2++)
                     {
								glo_get_part(temp5,nr2+1,temp7,',');
                        temp6[strlen(temp6)+1]='\0';
                        if (atoi(temp7)>0) temp6[strlen(temp6)]=atoi(temp7)+'A'-1;
								else temp6[strlen(temp6)]='?';
                     }
                     strcpy(temp5,temp6);

								 allfleks=dat_find_word(handle,handle->language.vocabulary,"","",temp5,0);
				         for (fleks=*allfleks,k1=0;fleks!=NULL;k1++,fleks=allfleks[k1])
				         for (odm=fleks->odm_head;odm!=NULL;odm=odm->next) {
								  nr2=glo_count_parts(handle,odm->odmiany,',');
								  for (poz=0;poz<nr2;poz++) {
		                  	// warunek: jakas odmiana musi istniec (tzn. musi byc podana)
		               glo_get_part(odm->odmiany,poz+1,temp6,',');
		               if (strlen(temp6)==0) continue;

									// tworzymy opis zakodowany
                           // w temp7 dane fleksji znalezionego zaimka
		         			if (nr2>1) sprintf(temp7,"%s%c",odm->opis,poz+'A');
		         			else sprintf(temp7,"%s",odm->opis);

									// jesli opisy sa zgodne, to ok
									if (gra_wyrazenie_check(handle,&posneg,lo8->cmp_data,temp7,temp4)==1) {
//DeniseReport(handle,"FOUNDED! %s",temp6);
										sprintf(table[temp3[nr1]-1],"%s",temp6);
										          free(allfleks);
                              goto WRITE_WORD;
									} else temp6[0]='\0';
								 }
                     }
								     free(allfleks);
                  }
               }
            }
         }
         WRITE_WORD:;
			if (temp[0]=='\0') strcpy(temp,table[temp3[nr1]-1]);
         else
         {
         	strcat(temp,temp1); // spacja
            strcat(temp,table[temp3[nr1]-1]);
         }
      }
//DeniseReport(handle,"%d=temp: %s",decl->results_number+1,temp);
      sprintf(decl->result[decl->results_number],"%s",temp);
      decl->results_number++;

//DeniseReport(handle,"!%s!",decl->result[decl->results_number-1]);

		NOT_GOOD:;
   }

   if (decl->results_number==0)
   {
		DeniseReport(handle,UNN_GetLocaleString(handle,MSG_DECLENSION_FAILED,"nie potrafie odmienic zdania - brak danych"));
      return FALSE;
   }

//   for (nr1=0;nr1<decl->results_number;nr1++)
//   	DeniseReport(handle,"zd: %d=%s",nr1+1,decl->result[nr1]);

	return TRUE;

nr10=0;
nr4=0;
	for (nr1=0;nr1<decl->groups_number;nr1++)
	{
		nr10=nr10+decl->group[nr1].types_number;

		for (nr2=0;nr2<decl->group[nr1].words_number;nr2++)
		{
			word=&(decl->group[nr1].word[nr2]);
         nr4+=word->fleks_number;
			for (nr3=0;nr3<word->fleks_number;nr3++)
			{
				glo_get_part(word->odm[nr3]->odmiany,word->poz[nr3],temp,',');
//DeniseReport(handle,"!%s!",word->odm[nr3]->odmiany);
				DeniseReport(handle,"grupa %d, slowo: %s, mozliwosc: %s (%d/%d - quality: %d)",nr1+1,word->podst,temp,nr3+1,word->fleks_number,word->utility[nr3]);
			}
		}
	}

	DeniseReport(handle,"MOZLIWOSCI: zdan: %d (zwiazkow: %d, odmian: %d)",decl->results_number,nr10,nr4);

	return TRUE;
}

static BOOL word_exist(struct Declension *decl,int nr,char *data)
{
	/*
   funkcja sprawdza, czy w podanej grupie o numerze nr1 w zmiennej decl
   jest wyraz o fleksji zgodnej z data
   */

	int nr1;

	for (nr1=0;nr1<decl->group[nr].words_number;nr1++)
		if (data[0]==decl->group[nr].word[nr1].odm[decl->group[nr].word[nr1].selected-1]->opis[0]) return TRUE;

   return FALSE;
}

